/**
 * 如果使用此组件, 页面组件必须引用
 * usingComponents: {
 *   "mp-icon": "weui-miniprogram/icon/icon"
 * }
 **/

import React, { useState, useEffect } from 'react'

export default props => {
  const [label, setLabel] = useState()
  const [pos, setPos] = useState()
  const { value, range=[], rangeKey, rangeValue, placeholder = '请选择', preTitle = '' } = props

  const handleChange = e => {
    const inx = e.detail.value - 0
    setPos(inx)
    if (props.onChange) {
      props.onChange(range[inx])
    }
  }
  
  useEffect(() => {
    let inited = false
    for (let i = 0; i < range.length; i ++) {
      const val = range[i][rangeValue]
      if (val === value) {
        setPos(i)
        inited = true
        break
      }
    }

    if (!inited) {
      setPos()
    }
  }, [value])

  useEffect(() => {
    if (pos || pos === 0) {
      setLabel(range[pos][rangeKey])
    } else {
      setLabel()
    }
  }, [pos])

  return (
    <picker value={pos} range={range} range-key={rangeKey} onChange={handleChange}>
      <view style="display: flex">
        <view style="flex: auto">{label ? `${preTitle} ${label}` : placeholder}</view>
        <view style="flex: none"><mp-icon icon="arrow" size={12}></mp-icon></view>
      </view>
    </picker>
  )
}
