import React, { useEffect, useRef, useState } from 'react'
import Taro, { useDidShow } from "@tarojs/taro";
import { useSelector, useDispatch } from "react-redux"
import { View, ScrollView, Button } from '@tarojs/components'
import Layout from '../../layout/index'
import Tab from '../../compents/tab/index'
import Picker from '../../compents/Picker/index'
// import Register from './register/index'
import Guide from '../guide/index'
import Recommend from '../recommend/index'
import HouseLIst from '../house/list/index'
import { AtFloatLayout } from "taro-ui"
import request from '@/util/request'
import './index.scss'
import NavCustom from '../../compents/navcustom'

const index = (props) => {
  const user = useSelector(state => state.user)
  const [isOpened, setIsOpened] = useState(false)
  const [userRole, setUserRole] = useState('1')
  const [pageState, setPageState] = useState('1')
  const [list, setList] = useState([])
  const [radioHouseData, setRadioHouseData] = useState()
  const [radioHouseState, setRadioHouseState] = useState(false)

  const shopList = (user.shopList || []).map(x => ({text: x.name, value: x.shopId}))
  const defaultShop = user.defaultShop

  const childRef = useRef();

  const dispatch = useDispatch()

  const handleClose = () => {
    setIsOpened(false)
  }
  const onTabClick = (e) => {
    setUserRole(e)

  }

  const onRegisterChange = (e) => {}

  const onCopy = (e) => {

    if (radioHouseData.houseId) {

      const {houseId,...data} = radioHouseData

      Taro.showLoading({
        title: '请稍候 ...',
        mask: true
      })

      request({ url: '/taHouse', method: 'post', data: { ...data, originId: houseId } }).then((res) => {
        Taro.hideLoading()

        Taro.showModal({
          title: '复制成功',
          content: '点击确认按钮，返回上级菜单',
          showCancel: false,
          success: function (res) {
            if (res.confirm) {
              console.log('用户点击确定')
            
              childRef.current.getRefHouseList();
              setRadioHouseState(false)
            } else if (res.cancel) {
              console.log('用户点击取消')
            }
          }
        })
      }).catch(e => Taro.hideLoading())
      // Taro.navigateTo({ url: '/pages/house/addnewhouse/index?id=radioHouseData.id'})
      // Taro.showModal({
      //   title: '修改成功',
      //   content: '点击确认按钮，返回上级菜单',
      //   showCancel:false,
      //   success: function (res) {
      //     if (res.confirm) {
      //       console.log('用户点击确定')

      //       Taro.navigateTo({ url: '/pages/house/addnewhouse/index?id=radioHouseData.id'})
      //     } else if (res.cancel) {
      //       console.log('用户点击取消')
      //     }
      //   }
      // })

    }

  }
  const navStyle =  Taro.getMenuButtonBoundingClientRect()
  

  const handleSelectShop = shop => {
    dispatch({ type: "SET_SHOP", shopId: shop.value });
  }

  return <View className='index'>
    <View>
      {pageState == '1' &&<NavCustom houseInfo={{title:'民宿房源管理'}}></NavCustom>}

      {
        shopList.length > 1 &&
        (
          <mp-cells>
            <mp-cell>
              <Picker
                value={defaultShop}
                range={shopList}
                rangeKey="text"
                rangeValue="value"
                preTitle="当前店铺: "
                placeholder="请选择店铺 ..."
                onChange={handleSelectShop}
              />
            </mp-cell>
          </mp-cells>
          // <mp-actionSheet show actions={shopList} title="请选择店铺" showCancel={false} onActiontap={handleSelectShop}>
          // </mp-actionSheet>
        )
      }

      <Layout type='custom'>
        {pageState == '1' && <HouseLIst ref={childRef} radioHouseState={radioHouseState} onChange={(e) => setRadioHouseData(e)}></HouseLIst>}
      </Layout>
      {!isOpened && <Tab className='addhousetab' value={['+添加房源']} onClick={(e) => setIsOpened(true)}></Tab>}
      {/* {pageState!='1' &&<Tab value={['入住指引','房东推荐']} pageState={pageState} onClick={(e)=>setPageState(e)}></Tab>} */}
      {radioHouseState && <Tab pageState='3' value={['取消', '确认复制']} onClick={[(e) => { setRadioHouseState(false), setIsOpened(false) }, () => onCopy()]}></Tab>}
    </View>



    <AtFloatLayout isOpened={isOpened} onClose={() => handleClose()} style={{ zIndex: '1000' }}>
      <View className='floatmodel' >
        <View style={{width:"100%" ,textAlign:'center'}} onClick={() => {setIsOpened(false);Taro.navigateTo({ url: '/pages/house/addnewhouse/index' })}}>新增房源</View>
        <View style={{width:"100%" ,textAlign:'center'}}  onClick={() => { setIsOpened(false); setRadioHouseState(true) }}>复制房源</View>
        <View style={{width:"100%" ,textAlign:'center', color: '#d2d2d2' }} onClick={() => setIsOpened(false)}>取消</View>
      </View>

    </AtFloatLayout>
  </View>
}

export default index