import React, { useEffect, useMemo, useState } from 'react'
import Taro, { useDidShow, useRouter } from "@tarojs/taro";
import { useSelector } from 'react-redux'
import { View, Input, Text, Image } from '@tarojs/components'
import Layout from '../../layout/index'
import Tab from '../../compents/tab/index'
import Container from '../../compents/container/index'
import locationicon from '../../assets/locationicon.png'
import './index.scss'
import request from '../../util/request';

const index = (props) => {

    const router = useRouter()

    const { houseId, type } = router.params

    const [userRole, setUserRole] = useState('1')
    const [pageState, setPageState] = useState('1')
    const [address, setAddress] = useState({})

//     // 在onInput详细地址时有bug，不能放在adderss里，所有加了个value
    const [value,setValue] = useState('')
//     // const [lngLat, setLngLat] = useState('')
// console.log(address,'setAddress')
    useDidShow(() => {

    })
    // shotAddress,  shotParking
    useEffect(() => {
        
        if (houseId) {
            getDetail()
        }

    }, [])
    const getDetail = () => {
        request({ url: `/taHouse/${houseId}` }).then((res) => {
            console.log(res.data.data,type, 'getDetail')
            const [ longitude,latitude] = (res.data.data.lngLat||'').split('____')
            if (type == "address") {
                
                setAddress({
                    // name:addressName,
                    address:res.data.data.address,
                    shortAddress:res.data.data.shortAddress,
                    longitude,
                    latitude
                })

                setValue(res.data.data.address)
                // setAddress(res.data.data.address)
                // setLngLat(res.data.data.lngLat)
            }else if (type == 'park'){
                // const [addressName,addressDetail] = (res.data.data.parking||'').split('____')
                setAddress({
                    // name:addressName,
                    address:res.data.data.parking,
                    shortAddress:res.data.data.shortParking,
                    longitude,
                    latitude
                })
                setValue(res.data.data.parking)
                // address(res.data.data)
                // setAddress(res.data.data.parking)
                // setLngLat(res.data.data.parkLngLat)
            }

        })
    }


    const onClick = (e) => {
        console.log(e, '111')
        let data = {}
        if (type == 'address') {
            data = {
                address: value,
                shortAddress:address.name,
       
                lngLat:`${address.latitude},${address.longitude}`
            }
        } else if (type == 'park') {
            data = {
                parking: value,
                shortParking:address.name,
                parkLngLat:`${address.latitude},${address.longitude}`
            }
        }
        console.log(data, '111')

        request({ url: `/taHouse/${houseId}`, method: 'put', data: { ...data, houseId } }).then((res) => {
            Taro.navigateBack({
                delta: 1
            })
        })
    }

    const onChooseLocation = () => {
        wx.getLocation({
            type: 'gcj02',
            success: data => {
                console.log('--定位-->', data)
                wx.chooseLocation({
                    latitude: data.latitude,
                    longitude: data.longitude,
                    success: (res) => {
                        console.log('--选择-->', res)        
                        setAddress({
                            ...res,
                            shortAddress:res.name
                        })
                        setValue(res.address)
                    },
                    fail: (err) => {
                        console.log(err)
                    },
                })
            },
            fail: e => {
                Taro.showToast({
                    title: '获取位置授权失败',
                    icon: 'none'
                })
                console.error(e)
            }
        })
    }

    return <View className='map'>




        <Layout>
            <View className='map-view' >
                <Text className='title'>位置信息</Text>
                <View style={{ display: 'flex' }}>
                    <Container className='map-view-card' style={{ width: '100%' }}>
                    {address.shortAddress&& <Input value={address.shortAddress} disabled placeholderClass='placeholderinput' className='input' type='text' placeholder='' />}

                    </Container>
                    <Container className='map-view-icon' onClick={() => onChooseLocation()}>
                        <Image className='icon' mode='widthFix' style={{ width: '100%' }} style={{ width: '40rpx' }} src={locationicon} />

                    </Container>
                </View>
            </View>
            <View className='map-view'>
                <Text className='title'>具体地址</Text>
                <Container className='map-view-card'>
                    <Input value={value} onInput={(e)=>setValue(e.detail.value)} placeholderClass='placeholderinput' className='input' type='text' placeholder='' />
                </Container>
            </View>
        </Layout>
        {pageState == '1' && <Tab className='addhousetab' pageState='3' value={['取消', '保存修改']} onClick={[(e) => Taro.navigateBack({
            delta: 1
        }), () => onClick()]}></Tab>}





    </View>
}

export default index